class TComponent:
    def __init__(self, owner):
        self.owner = owner
        self.components = []
        # Information about this object
        self.componentIndex = 0
        self.name = ''
        self.tag = None

    def appendComponent(self, component):
        self.components.append(component)
        component.owner = self

    def findComponent(self, name):
        name = string.lower(name)
        for component in self.components:
            if string.lower(component.name) == name:
                return component
        return None

    def removeComponent(self, component):
        try:
            del self.components[component]
        except:
            pass
        return

    def destory(self):
        for component in self.components:
            component.destroy()
        self.components = []

class TControl(TComponent):
    def __init__(self, owner):
        TComponent.__init__(self, owner)

_listnum = 0
class TStringList:
    onChanging = None         # before update event
    onChange = None           # after update event

    class _List:
        def __init__(self, owner):
            self._owner = owner
            self._data = []

        def __getitem__(self, index):
            return self._data[index]

        def __setitem__(self, index, value):
            self._owner.onChanging and self._owner.onChanging(self._owner)
            self._data[index] = value
            self._owner.onChange and self._owner.onChange(self._owner)
            return

        def __delitem__(self, index):
            self._owner.onChanging and self._owner.onChanging(self._owner)
            self._data[index] = value
            self._owner.onChange and self._owner.onChange(self._owner)
            return

        def __len__(self):
            return len(self._data)

    def __init__(self):
        self.strings = TStringList._List(self)
        self.objects = TStringList._List(self)
        self.text = ''
        self.count = 0

    def __setattr__(self, name, value):
        if name == 'text':
            import string
            strings = string.split(value, '\n')
            self.strings._data = strings
            self.objects._data = [None]*len(strings)
        self.__dict__[name] = value

    def add(self, str, obj=None):
        self.onChanging and self.onChanging(self)
        index = len(self.strings)
        self.strings._data.append(str)
        self.objects._data.append(obj)
        self.count = self.count + 1
        self.__dict__['text'] = '%s%s\n' % (self.text, str)
        self.onChange and self.onChange(self)
        return index

    def clear(self):
        self.onChanging and self.onChanging(self)
        self.strings._data = []
        self.objects._data = []
        self.count = 0
        self.onChange and self.onChange(self)
        return

    def delete(self, index):
        if 0 <= index < self.count:
            self.onChanging and self.onChanging(self)
            del self.strings._data[index]
            del self.objects._data[index]
            self.count = self.count - 1
            self.onChange and self.onChange(self)
        return

    def indexOf(self, str):
        try:
            return self.strings._data.index(str)
        except:
            return -1

