import string
import Tkinter
_tk = Tkinter
del Tkinter

from Forms import *
from Controls import *

class TScrolledLabel(_tk.Canvas):
    def __init__(self, owner, **options):
        self.owner = owner
        self.top = options.get('top', 0)
        self.left = options.get('left', 0)
        self.width = options.get('width',50)
        self.height = options.get('height',50)
        self.alignment = options.get('alignment', 'left')
        self.font = options.get('font', owner.font)
        self._textvar = _tk.StringVar()

        _tk.Canvas.__init__(self, owner)
        self._label = _tk.Label(self,
                                anchor='nw',
                                background='white',
                                font=self.font,
                                justify=self.alignment,
                                textvariable=self._textvar,
                                )

        #self._vbar = _tk.Scrollbar(self,
        #                           orient='vertical',
        #                           command=self.yview)

        #self._hbar = _tk.Scrollbar(self,
        #                           orient='horizontal',
        #                           command=self.xview)

        #self.configure(yscrollcommand=self._vbar.set,
        #               xscrollcommand=self._hbar.set)

        #self._vbar.pack(fill='y', side='left', expand=1)
        #self._hbar.pack(fill='x', side='bottom', expand=1)

        self._label.pack(fill='both', expand=1)
        self.update()
        item = self.create_window(0, 0, window=self._label, anchor='nw')
        # CAUTION: these work through __setattr__
        self.wordWrap = options.get('wordWrap', 1)
        self.align = options.get('align', alNone)
        #self.scrollBars = options.get('scrollBars', ssNone)

    def __setattr__(self, name, value):
        if name == 'text':
            self._textvar.set(value)
        elif name == 'wordWrap':
            wrap = value and self.width
            self._label.configure(wraplength=(value and self.width))
        elif name == 'align':
            self._set_align(value)
        elif name == 'scrollBars':
            self._set_scrollBars(value)
        self.__dict__[name] = value
        return

    def _set_align(self, align):
        if align == alNone:
            self.place(x=self.left, y=self.top,
                       width=self.width, height=self.height)
        elif align == alClient:
            self.pack(fill='both', expand=1)
        elif align in [alTop, alBottom]:
            self.place(height=self.height)
            self.pack(fill='x', expand=1, side=align)
        elif align in [alLeft, alRight]:
            self.place(width=self.width)
            self.pack(fill='y', expand=1, side=align)
        self.update()
        print self.winfo_width()
        return

    def _set_scrollBars(self, scrollStyle):
        # disable both by default
        vAnchor = 'nw'
        hAnchor = 'se'
        if scrollStyle in [ssVertical, ssBoth]:
            vAnchor = 'ne'
        if scrollStyle in [ssHorizontal, ssBoth]:
            hAnchor = 'sw'
            
        self._vbar.place(anchor='ne')
        self._hbar.place(anchor='se')
        return

    def setCaption(self,caption=None):
        if caption is not None:
            self.fullCaption = caption
        else:
            caption = self.fullCaption
            

        self.fullCaptionLines = string.split(self.fullCaption,'\n')
        self.numFullCaptionLines = len(self.fullCaptionLines)
        
        #Find the widest line
        self.fullCaptionMaxLength = 0
        for l in self.fullCaptionLines:
            if len(l) > self.fullCaptionMaxLength:
                self.fullCaptionMaxLength = len(l)


        #FIXME Remove after debugging
        if self.fullCaptionMaxLength == 0: return

        #Trim the lines
        captionLines = self.fullCaptionLines[self.captionVIndex:self.captionVIndex + self.lheight]

        start = self.captionHIndex
        end = self.lwidth-1
        for ctr in range(len(captionLines)):
            if ctr == len(captionLines) - 1:
                end = end + 1
            line = captionLines[ctr]
            line = string.replace(line,'\t','        ')
            if len(line[start:]) > end:
                captionLines[ctr] = line[start:start+end]
            else:
                captionLines[ctr] = line[start:]
                #PAdd it?
                if len(captionLines[ctr]) < end:
                    captionLines[ctr] = captionLines[ctr] + (' ' * (end - len(captionLines[ctr])))
                

        self.label.caption.set(string.join(captionLines,'\n'))

        #Adjust the HScrollbar
        if self.fullCaptionMaxLength == 0 or self.fullCaptionMaxLength <= self.lwidth:
            lo = 0.0
            hi = 1.0
        else:
            lo = float(self.captionHIndex) / float(self.fullCaptionMaxLength)
            hi = float(self.lwidth) / float(self.fullCaptionMaxLength)
            
        #self.hbar.set(lo,lo+hi)

        #Adjust the VScrollbar
        if self.numFullCaptionLines == 1:
            lo = 0.0
            hi = 1.0
        else:
            lo = float(self.captionVIndex) / float(self.numFullCaptionLines)
            hi = float(self.lheight) / float(self.numFullCaptionLines)
            
        #self.vbar.set(lo,lo+hi)

if __name__ == '__main__':

    from Forms import TApplication
    app = TApplication()
    SHORT_TEXT = "Hello World"
    LONG_TEXT = 'start'+("0123456" * 16) + 'end'
    LONG_MULTI_TEXT = 'start'+("0123456\n" * 16) + 'end'
    LONG_MULTI_TEXT2 = open('/usr/local/lib/xslt/api.xslt').read()

    form = app.createForm(TForm)
    form.sl = TScrolledLabel(form, align=alClient, wordWrap=0)
    
    form.sl.text = LONG_MULTI_TEXT2

    app.run()

