########################################################################
#
# File Name:            SystemDocDefContainerProxy.py
#
# Documentation:        http://docs.4suite.org/4SS/COS/Lib/XmlServerLib.py.html
#
"""
Implements the CORBA XmlServer service
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""
import omniORB
import FtServerResources
from Ft.Server.Protocols.CORBA import MessageSource
import ContainerProxy
import FtssTypes
import DocDefProxyHelper

from Ft.Server.Core import CreationParamsImp

#Overidden class
oldBase = omniORB.objrefMapping[FtServerResources.SystemDocDefContainerIf._NP_RepositoryId]
class SystemDocDefContainerProxyIf(oldBase,ContainerProxy.ContainerProxyIf):
    base = oldBase

    def createDocumentDefinition(self,name,nss,maps,cp):
        nss = DocDefProxyHelper.NsMapToCorba(nss)
        maps = DocDefProxyHelper.RdfMapsToCorba(maps)
        cp = DocDefProxyHelper.CreationParamsToCorba(cp)

        return self.base.createDocumentDefinition(self,name,nss,maps,cp)


for name,value in ContainerProxy.ContainerProxyIf.__dict__.items():

    if name in ['__doc__','base','__module__']:
        continue
    setattr(SystemDocDefContainerProxyIf,name,value)

omniORB.registerObjref(FtServerResources.SystemDocDefContainerIf._NP_RepositoryId, SystemDocDefContainerProxyIf)












