########################################################################
#
# File Name:            SystemUserContainerProxy.py
#
# Documentation:        http://docs.4suite.org/4SS/COS/Lib/XmlServerLib.py.html
#
"""
Implements the CORBA XmlServer service
WWW: http://4suite.org        e-mail: support@4suite.org

Copyright (c) 1999-2001 Fourthought Inc, USA.   All Rights Reserved.
See  http://4suite.org/COPYRIGHT  for license and copyright information
"""
import sha
import omniORB
import FtServerResources
from Ft.Server.Protocols.CORBA import MessageSource
import ContainerProxy

#Overidden class
oldBase = omniORB.objrefMapping[FtServerResources.SystemUserContainerIf._NP_RepositoryId]
class SystemUserContainerProxyIf(oldBase,ContainerProxy.ContainerProxyIf):
    base = oldBase

    def createUser(self,userName,password,passwordHash = None):
        if passwordHash is None:
            passwordHash = sha.new(password).hexdigest()
        
        return SystemUserContainerProxyIf.base.createUser(self,userName,passwordHash)

for name,value in ContainerProxy.ContainerProxyIf.__dict__.items():
    if name in ['__doc__','base','__module__']:
        continue
    setattr(SystemUserContainerProxyIf,name,value)

omniORB.registerObjref(FtServerResources.SystemUserContainerIf._NP_RepositoryId, SystemUserContainerProxyIf)












