from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import ExceptionUtil


import FtssTypes

class ContainerMixin:

    def len(self):
        return self._runSafe(self.resource.__len__,())

    def getitem(self,index):
        return self._runSafe(self.resource.__getitem__,(index,),self._mapResourceInformation)

    def getslice(self,start,end):
        return self._runSafe(self.resource.__getslice__,(start,end),self._mapResourceInformationList)

    def keys(self):
        return self._runSafe(self.resource.keys,())

    def values(self):
        return self._runSafe(self.resource.values,(),self._mapResourceInformationList)

    def items(self):
        return self._runSafe(self.resource.items,(),self._mapResourceItemsList)


    def has_key(self,name):
        return self._runSafe(self.resource.has_key,(name,))

    def get(self,name):
        return self._runSafe(self.resource.get,(name,),self._mapResourceInformation)


    def index(self,item):
        return self._runSafe(self._index,(item,))
        
    def _index(self,item):
        ctr = 0
        for ri in self.resource.values():
            if ri.uri == item.uri:
                return ctr
            ctr = ctr + 1
        return -1

    def _mapResourceInformationList(self,l):
        res = []
        for r in l:
            res.append(self._mapResourceInformation(r))
        return res

    def _mapResourceItemsList(self,l):
        res = []
        for n,r in l:
            ri = self.resource.fetchResourceInformation(r.getUri())
            res.append(FtssTypes.ResourceInformationItem(n,self._mapResourceInformation(ri)))
        return res
