import FtssTypes
import FtServerResources__POA, FtServerResources

from Ft.Server.Protocols.CORBA.FtOmniorb import OoRepositoryObjectImp
from Ft.Server.Protocols.CORBA.FtOmniorb.Lib import CorbaUtil, ExceptionUtil, DocDefCorbaHelper
from Ft.Server.Protocols.CORBA.FtOmniorb.Client import DocDefProxyHelper

from Ft.Server.Core import Constants

class RawFileImp(FtServerResources__POA.RawFileIf,OoRepositoryObjectImp.RepositoryObjectImp):


    def getImt(self):
        return self._runSafe(self.resource.getImt,())

    def getContent(self):
        return self._runSafe(self.resource.getContent,())

    def getCreationFlags(self):
        return self._runSafe(self.resource.getCreationFlags,(),int)

    def getValidationInfo(self):
        return self._runSafe(self.resource.getValidationInfo,(),self._mapValidationInfo)

    def setImt(self,imt):
        return self._runSafe(self.resource.setImt,(imt,))

    def setContent(self,src):
        return self._runSafe(self.resource.setContent,(src,))

    def applyXslt(self,stylesheets,params,ignorePis,extModules):
        extParams = {}
        newParams = {}
        for p in params:
            newParams[p.name] = p.value

        stylesheets = map(lambda x,f=DocDefCorbaHelper.DocumentReferenceFromCorba:f(x),stylesheets)

        rt = self._runSafe(self.resource.applyXslt,(stylesheets,newParams,ignorePis,extParams,extModules))
        outExtParams = []
        for name,value in extParams.items():
            outExtParams.append(XsltParameter(name,value))
        return (rt[0],rt[1],outExtParams)
                                
                           

    def _mapValidationInfo(self,vd):
        return DocDefProxyHelper.ValidationInfoToCorba(vd)

